#include <QLineEdit>
#include "HexDelegate.hxx"

// --- internal constants ---

const QChar Null('0');
const QRegExpValidator VLatin1(QRegExp("\\H\\H"));

// --- constructors and deconstructors ---

HexDelegate::HexDelegate(QObject *parent)
: QStyledItemDelegate(parent)
{
}

HexDelegate::~HexDelegate()
{
}

// --- public methods ---

QWidget *HexDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem& /*option*/,
    const QModelIndex& /*index*/) const
{
    QLineEdit *editor = new QLineEdit(parent);

    editor->setValidator(&VLatin1);
    editor->setFrame(false);

    return editor;
}

void HexDelegate::setEditorData(QWidget *editor, const QModelIndex& index) const
{
    QLineEdit *ed = static_cast<QLineEdit *>(editor);
    const qint32 chr = index.model()->data(index, Qt::EditRole).toInt();

    ed->setText(QString("%1").arg(chr, 2, 16, Null));
}

void HexDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
    QLineEdit *ed = static_cast<QLineEdit *>(editor);

    model->setData(index, ed->text(), Qt::EditRole);
}

void HexDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem& option,
    const QModelIndex& /*index*/) const
{
    editor->setGeometry(option.rect);
}
