#pragma once

#include <limits>
#include <QObject>

namespace NC
{
    namespace Meta
    {
        const quint32 Error = std::numeric_limits<quint32>::max();

        enum Type : quint64 {
            T00 = 0x0,
            T01 = 0x1,
            T02 = 0x2,
            T03 = 0x4,
            T04 = 0x8,
            T05 = 0x10,
            T06 = 0x20,
            T07 = 0x40,
            T08 = 0x80,
            T09 = 0x100,
            T10 = 0x200,
            T11 = 0x400,
            T12 = 0x800,
            T13 = 0x1000,
            T14 = 0x2000,
            T15 = 0x4000,
            T16 = 0x8000,
            T17 = 0x10000,
            T18 = 0x20000,
            T19 = 0x40000,
            T20 = 0x80000,
            T21 = 0x100000,
            T22 = 0x200000,
            T23 = 0x400000,
            T24 = 0x800000,
            T25 = 0x1000000,
            T26 = 0x2000000,
            T27 = 0x4000000,
            T28 = 0x8000000,
            T29 = 0x10000000,
            T30 = 0x20000000,
            T31 = 0x40000000,
            T32 = 0x80000000,
            T33 = 0x100000000,
            T34 = 0x200000000,
            T35 = 0x400000000,
            T36 = 0x800000000,
            T37 = 0x1000000000,
            T38 = 0x2000000000,
            T39 = 0x4000000000,
            T40 = 0x8000000000
        };
    }

    namespace FileData
    {
        enum Type : quint8 {
            None = Meta::Type::T00,
            HSize = Meta::Type::T01,
            Position = Meta::Type::T02,
            CSize = Meta::Type::T03,
            OSize = Meta::Type::T04,
            NameLength = Meta::Type::T05,
            Name = Meta::Type::T06,
            CData = Meta::Type::T07,
            OData = Meta::Type::T08,
            All = HSize + Position + CSize + OSize + NameLength + Name + CData + OData
        };
    }

    namespace Identify
    {
        enum Type : quint32 {
            Error = Meta::Error,
            Plain = Error - 1,
            ZLIB = Error - 2,
            VFS = 0x3D458CDE,
            PAK1 = 0x883DF70A,
            PAK2 = 0x93847584,
            PAK3 = 0xABFDEFBD
        };
    }
}
