#pragma once

#include <QSyntaxHighlighter>

class IniSyntax : public QSyntaxHighlighter {
    Q_OBJECT
public:
    explicit IniSyntax(QObject *parent = 0);
    explicit IniSyntax(QTextDocument *parent = 0);
    virtual ~IniSyntax();

protected:
    virtual void highlightBlock(const QString& text) override;
    void setup();

private:
    QTextCharFormat _keywords_f;
    QTextCharFormat _ints_f;
    QTextCharFormat _strings_f;
    QTextCharFormat _comment_f;
    QRegExp _keywords_re;
    QRegExp _ints_re;
    QRegExp _strings_re;
    QRegExp _comment_re;
};
